// BinaryToCode.cpp

// oCiR[h𖄂ߍݗpR[hɕϊ
// helpTextQ

#pragma warning (disable : 4996 )

#include <tchar.h>
#include "fstream"


const char* helpText =
	"BinaryToHeader v1.00\n"
	"(C)~`ǂƃR\n"
	"http://marupeke296.com\n"
	"BinaryToHeader [filePath] [argumentName] [outputFilePath]\n";

const char* header = {
	"// Resource Code\n"
	"//\n"
	"const unsigned char "
};


int _tmain(int argc, _TCHAR* argv[])
{
	if ( argc <= 3 ) {
		printf( helpText );
		return 0;
	}

	std::ifstream ifs( argv[1], std::ios_base::in | std::ios_base::binary );
	if ( !ifs.is_open() ) {
		printf( "̓t@C̃I[vɎs܂(%s)\n", argv[1] );
		return 0;
	}

	std::ofstream ofs( argv[3] );
	if ( !ofs.is_open() ) {
		printf( "o̓t@C̃I[vɎs܂(%s)\n", argv[2] );
		return 0;
	}

	// ̓t@C̃oCiunsigned charf[^ɕϊ
	ifs.seekg( 0, std::ios_base::end );
	const size_t sz = ifs.tellg();
	ifs.seekg( std::ios_base::beg );
	unsigned char *outData = new unsigned char[sz];
	ifs.read( (char*)outData, (std::streamsize)sz );

	ofs.write( header, (std::streamsize)strlen(header) );
	ofs.write( argv[2], (std::streamsize)strlen(argv[2]) );
	ofs.write( "[] = {\n", 7 );
	char dataText[8];
	for ( size_t i = 0; i < sz; i++ ) {
		if ( i % 8 == 0 )
			ofs.write( "\t", 1 );
		memset( dataText, 0, 8 );
		sprintf( dataText, "%3d, ", outData[i] );
		ofs.write( (const char*)dataText, (std::streamsize)strlen(dataText) );
		if ( i % 8 == 7 )
			ofs.write( "\n", 1 );
	}
	ofs.write( "\n};\n", 4 );

	// I
	printf( "Converted from %s to %s.\n", argv[1], argv[3] );

	delete[] outData;

	return 0;
}
